"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendMessages = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const sendMessages = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outLatched).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toQueryRequest(rule)).through((0, _utils.queryDynamoDB)(rule)).map(toGetRequest(rule)).through((0, _utils.batchGetDynamoDB)(rule)).map(toMessage(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through(rule.sns || rule.topicArn ? (0, _utils.publishToSns)(rule) : (0, _utils.sendToSqs)(rule)).tap(_utils.printEndPipeline);

exports.sendMessages = sendMessages;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toQueryRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  queryRequest: rule.toQueryRequest ?
  /* istanbul ignore next */
  rule.toQueryRequest(uow, rule) : undefined
}));

const toGetRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  batchGetRequest: rule.toGetRequest ?
  /* istanbul ignore next */
  rule.toGetRequest(uow, rule) : undefined
}));

const toMessage = rule => (0, _utils.faultyAsyncStream)(async uow => ({ ...uow,
  message: await (0, _utils.faultify)(rule.toMessage)(uow, rule)
}));